import java.io.*;
import java.util.Properties;
import java.net.InetAddress;

public class BanHandler
{
    private static Properties ips = new Properties();
    private static Properties names = new Properties();

    public static void ban(String name)
    {
        names.setProperty(name, "true");
        save();
    }

    public static void ban(InetAddress ia)
    {
        ips.setProperty(ia.getHostAddress(), "true");
        save();
    }

    public static void unBan(InetAddress ia)
    {
        ips.setProperty(ia.getHostAddress(), "false");
        save();
    }

    public static void unBan(String name)
    {
        names.setProperty(name, "false");
        save();
    }

    public static boolean isBanned(String name)
    {
        if(names.containsKey(name))
            return Boolean.parseBoolean(names.getProperty(name));
        names.setProperty(name, "false");
        save();
        return false;
    }

    public static boolean isBanned(InetAddress ia)
    {
        if(ips.containsKey(ia.getHostAddress()))
            return Boolean.parseBoolean(ips.getProperty(ia.getHostAddress()));
        ips.setProperty(ia.getHostAddress(), "false");
        save();
        return false;
    }

    public static void load()
    {
        try{
            try{
                File dir = new File("Bans");
                if(!dir.exists())
                    dir.mkdir();
                File ipsFile = new File(dir, "ips.xml");
                ips.loadFromXML(new FileInputStream(ipsFile));
                File namesFile = new File(dir, "names.xml");
                names.loadFromXML(new FileInputStream(namesFile));
            }
            catch(FileNotFoundException fnfe){
            }
        }
        catch(IOException ioe){
            ioe.printStackTrace();
        }
    }

    public static void save()
    {
        try{
                File dir = new File("Bans");
                if(!dir.exists())
                    dir.mkdir();
                File ipsFile = new File(dir, "ips.xml");
                ips.storeToXML(new FileOutputStream(ipsFile), "");
                File namesFile = new File(dir, "names.xml");
                names.storeToXML(new FileOutputStream(namesFile), "");
        }
        catch(Exception e){
            System.out.println("Error saving ban lists:\n\t" + e);
        }
    }

    static{
        load();
    }
}
